<id>
Registration Approval for YaBB 2.1 
</id>

<version>
1.96
</version>

<mod info>
This mod add the following functions to registration:
- admin/gmod registration approval
- send email when new member regitered
- member's reason for joining 
To activate, go into the admin center.

Approval setting: 
"Approval Off"
"Approval On - View Mode Access Only" : enable all functions for user except post, pmsend, mailsend and memberlist view
"Approval On - User Profile Access Only" :  enable only login/logout and own profile modify
"Approval On - Before Join"

The three approval method working with pre-registration and free-registration too.

Do Approval/Unapproval a members in Membercontrols section of Admincenter.
Can add custom text to the approval/disapproval email.


Installation:
0) Uninstall previous version
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
Admin/ModList.pl
Admin/AdminSubList.pl
Admin/AdminEdit.pl
AdminIndex.pl
Sources/Register.pl
Sources/Security.pl
Sources/Profile.pl
Sources/LoginOut.pl
Sources/BoardIndex.pl
Languages/English/Admin.lng
Languages/English/BoardIndex.lng
Templates/Default/BoardIndex.template
3) Load attached files to your server in ASCII mode.
Admin/ApprovalMembers.pl
Languages/English/Approval.lng

Version History:
ver 1.96
 - fixed Internal Server Error when set 'New registered member email sent to' more user
 - fixed deleted member in the approval/disapproval list

ver 1.95
 - minor change in language file
 - beta state
ver 1.94
 - fixed approved mail text
 - fixed reason in pereregister formula
ver 1.93
 - added reason to live profile too
ver 1.92
 - added member's regdate checking to show reason
 - added boardlink to approved email
ver 1.91
 - fixed MOD syntax bug, AdminSection, link in email
 - reload viewprepofile sub (simple file-view)
 - fixed forced reason for joining
 - fixed member does not get put on the memberlist when admin/gmod approve him. 
ver 1.9
 - remove approval before confirmed method
 - add approval before join method
 - add registering users's IP to memberlist
 - pre registered but not joined members's data showed in profile page
 - fixed 'null reason' bug
 - reason to force out 
 - add reason view to profile page 
 - cleaned code
ver 1.7
 - more
ver 1.6
 - Fixed: more
ver 1.5
 - Fixed pereregister double approval bug
 - Language file revised 
 - Added: preregged and but approved member not deleted from inactive list
 - Added: preregged member start time once the admin/gmod approves the member's account
 - Add: delete entry to registration log if disapproval a preregged member
ver 1.4
 - Fixed .. as god as everything (??)
ver 1.31
 - Fixed MOD Step 2, 3
 - Fixed small typo in the popup window
 - New message to pre-registering with approval setting
ver 1.3
  - added mail to selected admin/gmods if new user regged
  - added pre-register -> approval -> activation method
  - added reg status (full or pre) to approvallist
ver 1.21
 - Fixed Gmod access
 - Fixed waitlist bug
ver 1.2
 - added fast listfile with not confirmed members
 - added number of not confirmed members on boardindex infocenter section, link to approval
 - approval switch to free registration options 
 - enable/disabale Global Moderator access to approval functions
 - email field to member list
 - Removed automatic logout, if approval set is 2 and disallowed a function
 - Minor cosmetic in Englis.lng
ver 1.11
 - Ban & modfunction Mod compatible.
ver 1.1
 - Convert to Y2.1 format
ver 1.0
 - Initial beta release (but Y2.2 format:P)
</mod info>

<author>
Zoo
</author>

<homepage>

</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$reg_approval = "Registration Approval|Zoltan Kovacs (Zoo)|This mod add the following funtons to registration:<br />- admin/gmod registration approval<br />- send email when new member regitered<br />- member's reason for joining<br /><br /><span class=\"small\"><b>Credits:</b> Thanks for '<b>DOT-COM</b>' with mod testing, language fixing and idea cleaning ;)</span>|1.96|06/05/07";
	push (@installed_mods, "$reg_approval");
</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'approvalmembers',"ApprovalMembers.pl&MLDate",
'approvalmultimembers',"ApprovalMembers.pl&ApprovalMultiMembers", 
'viewpreprofile',"ApprovalMembers.pl&ViewPreProfile", 
</add after>

<edit file>
Admin/AdminEdit.pl
</edit file>

<search for>
LoadLanguage("Register");
</search for>

<add after>
LoadLanguage("Approval");
</add after>


<search for>
	if    ($preregister)         { $preregchecked       = ' checked="checked" '; }
</search for>

<add after>
	if    ($needapproval == 0) { $appres1       = " selected=\"selected\" "; }
	elsif ($needapproval == 1) { $appres2       = " selected=\"selected\" "; }
	elsif ($needapproval == 2) { $appres3       = " selected=\"selected\" "; }
	elsif ($needapproval == 3) { $appres4       = " selected=\"selected\" "; }
	if    ($newregmail)          { $newregmailchecked   = ' checked="checked" '; }
	if    ($regreason)           { $regreasonchecked    = ' checked="checked" '; }
</add after>

<search for>
	<br />
		<div class="setting_cell">$prereg_txt{'7'}</div>
		<div class="setting_cell2"><input type="checkbox" name="preregister"$preregchecked /></div>
	<br />
		<div class="setting_cell">$prereg_txt{'11'}</div>
		<div class="setting_cell2"><input type="text" name="preregspan" size="5" value="$preregspan" /></div>
</search for>

<replace>
	<br />
		<div class="setting_cell">$approval_txt{'needreason'}</div>
		<div class="setting_cell2"><input type="checkbox" name="regreason"$regreasonchecked /></div>
	<br />
		<div class="setting_cell">$prereg_txt{'7'}</div>
		<div class="setting_cell2"><input type="checkbox" id="preregister "name="preregister"$preregchecked /></div>
	<br />
		<div class="setting_cell">$prereg_txt{'11'}</div>
		<div class="setting_cell2"><input type="text" name="preregspan" size="5" value="$preregspan" /></div>
	<br />
		<div class="setting_cell">$approval_txt{'need'}</div>
		<div class="setting_cell2">
		<select name="needapproval" size="1">
			<option value="0"$appres1>$approval_txt{'no'}</option>
			<option value="1"$appres2>$approval_txt{'soft'}</option>
			<option value="2"$appres3>$approval_txt{'hard'}</option>
			<option value="3"$appres4>$approval_txt{'join'}</option>
		</select>
		</div>
	<br />
		<div class="setting_cell">$approval_txt{'sendmail'}</div>
		<div class="setting_cell2"><input type="checkbox" name="newregmail" $newregmailchecked /></div>
	<br />
		<div class="setting_cell">$approval_txt{'sendto'}</div>
		<div class="setting_cell2"><input type="text" name="newregmailto" size="50" value="$newregmailto" /></div>
</replace>

<search for>
'viewmembers',"$FORM{'viewmembers'}",
</search for>

<add after>
'approvalmembers',"$FORM{'approvalmembers'}",
</add after>

<search for>
deletemultimembers => "$FORM{'viewmembers'}",
</search for>

<add after>
approvalmultimembers,"$FORM{'approvalmembers'}",
</add after>

<search for>
	$preregspan = $FORM{'preregspan'} || 24;
</search for>

<add after>
	$regreason = $FORM{'regreason'} || 0;
	$needapproval = $FORM{'needapproval'} || 0;
	$needapproval = 0 if $regdisable;
	$newregmail = $FORM{'newregmail'} || 0;
	$newregmailto = $FORM{'newregmailto'};
	$newregmailto =~ s/ /,/g;
	my @newregmailtolist = split(/\,/, $newregmailto);
	$newregmailto = "";
	foreach $testuser (@newregmailtolist) {
		&LoadUser($testuser);
		if ( ${$uid.$testuser}{'position'} eq 'Administrator' || ${$uid.$testuser}{'position'} eq 'Global Moderator' ) {
			$newregmailto .= "," if $newregmailto;
			$newregmailto .= $testuser;
		}
	}
	$newregmailto = qq~"$newregmailto"~;

</add after>

<search for>
\$preregspan = $preregspan;				# Time span in hours for users to account activation before cleanup.
</search for>

<add after>
\$regreason = $regreason;				# Need reason for registration
\$needapproval = $needapproval;				# Account approval by admin/gmod. 0 = disable. 1 = soft. 2 = hard, 3 = before join
\$newregmail = $newregmail;				# Send email with new registration to selected admin/gmod
\$newregmailto = $newregmailto;				# Mail to this member if a new member are registered
</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
	@member_controls = ("|$admintxt{'a6_title'}|$admintxt{'a6_label'} - $admintxt{'34'}|a6", "addmember|$admintxt{'a6_sub1'}|$admintxt{'a6_label1'}|", "viewmembers|$admintxt{'a6_sub2'}|$admintxt{'a6_label2'}|", "modmemgr|$admintxt{'a6_sub3'}|$admintxt{'a6_label3'}|", "mailing|$admintxt{'a6_sub4'}|$admintxt{'a6_label4'}|", "ipban|$admintxt{'a6_sub5'}|$admintxt{'a6_label5'}|", "setreserve|$admintxt{'a6_sub6'}|$admintxt{'a6_label6'}|",);
</search for>

<replace>
	@member_controls = ("|$admintxt{'a6_title'}|$admintxt{'a6_label'} - $admintxt{'34'}|a6", "addmember|$admintxt{'a6_sub1'}|$admintxt{'a6_label1'}|", "viewmembers|$admintxt{'a6_sub2'}|$admintxt{'a6_label2'}|", "approvalmembers|$admintxt{'a6_sub7'}|$admintxt{'a6_label7'}|", "modmemgr|$admintxt{'a6_sub3'}|$admintxt{'a6_label3'}|", "mailing|$admintxt{'a6_sub4'}|$admintxt{'a6_label4'}|", "ipban|$admintxt{'a6_sub5'}|$admintxt{'a6_label5'}|", "setreserve|$admintxt{'a6_sub6'}|$admintxt{'a6_label6'}|",);
</replace>

<edit file>
Sources/Register.pl
</edit file>

<search for>
LoadLanguage('Register');
</search for>

<add after>
LoadLanguage('Approval');
</add after>

<search for>
	if ($RegAgree) {
</search for>

<add before>
	if($regreason && !$regdisable) { 
		$yymain .= qq~
  <tr class="windowbg">
    <td>* <b>$approval_txt{'enterreason'}:</b></td>
    <td><textarea name="reason" rows=5 cols=80>$approval_txt{'defaultreason'}</textarea></font></td>
  </tr>
~;
	}

</add before>

<search for>
	if ($send_welcomeim == 1 && $preregister == 0) {
</search for>

<add before>
	if ($regreason && (!$member{'reason'} || length($member{'reason'}) < 4)) {
		&fatal_error("$approval_txt{'errorreason'}");
	}
</add before>

<search for>
		&UserAccount($reguser, "preregister");
</search for>

<add after>
		&WriteReason($member{'username'},$member{'reason'},$date) if $regreason;
</add after>


<search for>
		&UserAccount($reguser, "register") & MemberIndex("add", $reguser) & FormatUserName($reguser);
</search for>

<replace>
#		&UserAccount($reguser, "register") & MemberIndex("add", $reguser) & FormatUserName($reguser);
		if ($needapproval == 3) { # approve before joing
			&UserAccount($reguser, "register");
			rename("$memberdir/$reguser.vars", "$memberdir/$reguser.wait.vars");
		} else {
			&UserAccount($reguser, "register") & MemberIndex("add", $reguser) & FormatUserName($reguser);
		}

		# free register but need approval
		&ApprovalSet if $needapproval;
		&SendNewRegMail if $needapproval;
		&WriteReason($member{'username'},$member{'reason'},$date) if $regreason;
</replace>


<search for>
				# user is in list and the keys match, so let him/her in
				rename("$memberdir/$reguser.pre", "$memberdir/$reguser.vars");
				&UserCheck($reguser, "email");
				&MemberIndex("add", $reguser);
</search for>

<replace>
				# user is in list and the keys match, so let him/her in
				if ($needapproval == 3) { # 3: approval before join;
					rename("$memberdir/$reguser.pre", "$memberdir/$reguser.wait.vars");
				} else {
					# user is in list and the keys match, so let him/her in
					rename("$memberdir/$reguser.pre", "$memberdir/$reguser.vars");
					&UserCheck($reguser, "email");
					&MemberIndex("add", $reguser);
				}
				&ApprovalSet if $needapproval;
				&SendNewRegMail if $needapproval;
</replace>

<search for>
1;
</search for>

<add before>
sub ApprovalSet {
	fopen(APPROVAL, ">$memberdir/$reguser.wait");
	print APPROVAL $user_ip;
	fclose(APPROVAL);
	fopen (WAIT, ">>$memberdir/waitlist.txt");
	print WAIT "$reguser\n";
	fclose (WAIT);

	# language text update
	if ($needapproval == 1) {
		$register_txt{'130'} .= qq~\n\n$approval_txt{'displayregsoft'}~;
		$register_txt{'703'} .= qq~<br /><br />$approval_txt{'displayregsoft'}~;
		$register_txt{'431'} .= qq~<br /><br />$approval_txt{'displayregsoft'}~;
		$prereg_txt{'5'}     .= qq~<br /><br />$approval_txt{'displayregsoft'}~;
	}
	elsif ($needapproval == 2) {
		$register_txt{'130'} .= qq~\n\n$approval_txt{'displayreghard'}~;
		$register_txt{'703'} .= qq~<br /><br />$approval_txt{'displayreghard'}~;
		$register_txt{'431'} .= qq~<br /><br />$approval_txt{'displayreghard'}~;
		$prereg_txt{'5'}     .= qq~<br /><br />$approval_txt{'displayreghard'}~;
	}
	elsif ($needapproval == 3) {
		$register_txt{'130'} .= qq~\n\n$approval_txt{'displayregbefore'}~;
		$register_txt{'703'} .= qq~<br /><br />$approval_txt{'displayregbefore'}~;
		$register_txt{'431'} .= qq~<br /><br />$approval_txt{'displayregbefore'}~;
		$prereg_txt{'5'}      = qq~$approval_txt{'displayregbefore_act'}<br /><br />$approval_txt{'displayregbefore'}~;
	}
}

sub SendNewRegMail {
	return if !$newregmail;

	my @newregmailtolist = split(/\,/, $newregmailto); 
	foreach $mailtouser (@newregmailtolist) {
		&LoadUser($mailtouser);
		next if ! $uid.$mailtouser{'email'};

		$emailsubject = $approval_txt{'newreg'};
		$emailsubject .= ": $mbname";

		$emailtext  = qq~$approval_txt{'newmember'}$reguser\n\n~;
		$emailtext .= qq~$approval_txt{'linktoprofile'}$scripturl?action=viewprofile;username=$reguser\n~;
		$emailtext .= qq~$approval_txt{'or'}\n~;
		$emailtext .= qq~$approval_txt{'linktoprofilefile'}$boardurl/AdminIndex.$yyaext?action=viewpreprofile;username=$reguser\n\n~;

		$emailtext .= qq~$approval_txt{'linktoapproval'}$boardurl/AdminIndex.$yyaext?action=approvalmembers~ if $needapproval;

		&sendmail(${$uid.$mailtouser}{'email'}, $emailsubject, $emailtext);
	}
}

sub WriteReason {
	return if !$regreason;

	# CheckReason;
	$_[1] =~ s/\|/\&#124;/g; 
	$convertstr = $_[1];
	$convertcut = 500;
	&CountChars;
	$_[1] = $convertstr;

	fopen(REASON, ">>$memberdir/regreason.txt");
	print REASON qq~$_[0]|$_[1]|$_[2]\n~;
	fclose(REASON);
}

</add before>

<edit file>
Sources/Security.pl
</edit file>

<search for>
sub banning {
</search for>

<add after>
	if ($needapproval && -e "$memberdir/$username.wait" ) {
		LoadLanguage("Approval");
		if ($needapproval==1) {
			my @notallowaction = ('post','post2','imsend','imsend2','ml','mailto');
			if (grep /^$action$/, @notallowaction) {
				&fatal_error("$approval_txt{'dear'} ${$uid.$username}{'realname'}!<br />$approval_txt{'displaysoft'}");
			}
		}
		if ($needapproval==2) {
			my @allowaction = ('im','imshow','viewprofile','profileCheck','profileCheck2','profile','profile2','profileContacts','profileContacts2','profileOptions','profileOptions2','profileIM','profileIM2','logout','login','login2');
			if (! grep /^$action$/, @allowaction) {
				&fatal_error("$approval_txt{'dear'} ${$uid.$username}{'realname'}!<br />$approval_txt{'displayhard'}");
			}
		}
	}
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
sub ProfileCheck {
</search for>

<add before>
if ($iamadmin || $iamgmod) {
	$userorig = $INFO{'username'};
	my $user = $INFO{'username'};
  	if ( (! -e "$memberdir/$user.vars") && (-e "$memberdir/$user.wait.vars") && (-e "$memberdir/$user.wait")) {
		$notjoinedprofile=1;
		$INFO{'username'} .= ".wait";
		$profile_txt{'453'} .= "- $user";
	}
}

</add before>

<search for>
		$showusertext = "";
	}
</search for>

<add after>

	### load reason
	fopen(REASON, "$memberdir/regreason.txt");
	@reasons = <REASON>;
	fclose(REASON); 
	chomp @reasons;
	$reason{$user}="";
	for ($i=0; $i<@reasons;$i++) {
		($reasonname,$reasontxt,$reasondate) = split(/\|/, $reasons[$i]); 
		if ($reasonname eq $userorig && ($reasondate==${$uid.$user}{'regtime'})) { $reason{$user} = $reasontxt; last;}
	}

	LoadLanguage("Approval");
	$reasonblock .= qq~
	<tr>
		<td class="windowbg2" align="left" valign="top">
			<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
			<b>$approval_txt{'memberreason'}: </b>
			</div>
			<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
			$reason{$user}
			</div>
		</td>
	</tr>
~;
	$yymain .= qq~
<table border="0" cellpadding="8" cellspacing="1" class="bordercolor" align="center" width="570">
~;
	if ($notjoinedprofile) {
	$yymain .= qq~
	<tr>
		<td class="titlebg" width="100%" align="center">
			<div class="text1" style="float: center; width: 100%;">
			$approval_txt{'realusername'} $userorig<br />
			$INFO{'username'} $approval_txt{'workusername'}<br / >
			$approval_txt{'notjoinedprofile'}</b>
			</div>
		</td>
	</tr>
	$reasonblock
</table>
<br />~;
	}
</add after>

<search for>
  ~;

	if ($row_gender || $row_age || $row_location) {
</search for>

<add before>
$reasonblock
</add before>

<search for>
	} else {
		return 1;
	}
</search for>

<replace>
	} else {
		my $checkwait = $INFO{'username'};
		$checkwait =~ s/\.wait$//;
  		if ( -e "$memberdir/$checkwait.wait.vars" && -e "$memberdir/$checkwait.wait") {
	    		my @notallowaction = ('ModifyProfile2','ModifyProfileContacts2','ModifyProfileOptions2','ModifyProfileIM2','ModifyProfileAdmin2');
	    		if ( $action =~ /2$/ ) {
				LoadLanguage("Approval");
				&fatal_error("$checkwait : $approval_txt{'notjoined'}");
			}
		}
		return 1;
	}
</replace>

<edit file>
Sources/LoginOut.pl
</edit file>

<search for>
	&LoadIMs;
</search for>

<add before>
	if ($needapproval==2 && -e "$memberdir/$username.wait" ) {
		$yySetLocation = qq~$scripturl?action=viewprofile;username=$username~;
		&redirectexit;
	}
</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	$boardindex_template =~ s/<yabb membercount>/$membercountlink/g;
</search for>

<add after>
	if ($iamadmin || $iamgmod ) {
		fopen(WAIT, "$memberdir/waitlist.txt");
		@waitlist=<WAIT>;
		fclose(WAIT);
		if (@waitlist) {
			$waitcount = scalar @waitlist;
			$memberwaitcount .= qq~<a href="$boardurl/AdminIndex.$yyext?action=approvalmembers">$boardindex_txt{'wait'}: <b>$waitcount</b></a></b><br />~
		}
	}
	$boardindex_template =~ s/<yabb memberwaitcount>/$memberwaitcount/g;
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'17a' => "Add Member",
</search for>

<add after>
'17b' => "Approval/Disapproval Members",
</add after>

<search for>
'a6_label2' => "View/Delete Members",
</search for>

<add after>
'a6_sub7' => "Approval/Disapproval Members",
'a6_label7' => "Approval/Disapproval Members",
</add after>

<edit file>
Languages/English/BoardIndex.lng
</edit file>

<search for>
'guest_ip' => "Guest IP's",
</search for>

<add after>
'wait', => "Unconfirmed Members",
</add after>

<edit file>
Templates/Default/BoardIndex.template
</edit file>

<search for>
			$boardindex_txt{'487'} <yabb membercount> $boardindex_txt{'488'}.<br />
</search for>

<add after>
			<yabb memberwaitcount>
</add after>

