###############################################################################
# ApprovalMembers.pl                                                          #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$approvalbersplver = 'YaBB 2.1 $Revision: 1.96 $';
if ($action eq 'detailedversion') { return 1; }

&is_admin_or_gmod;

LoadLanguage("Main");
LoadLanguage("Approval");

if (defined $INFO{'rebuild'}) {
	&CreateWaitList;
	$yySetLocation = qq~$adminurl?action=approvalmembers~;
	&redirectexit;
}

my ($sortmode, $sortorder);
$MembersPerPage = $TopAmmount;

if ($INFO{'start'} eq "") { $start = 0; }
else { $start = "$INFO{'start'}"; }

if ($FORM{'sortform'} eq "username" || $INFO{'sort'} eq "username") { $selUser .= qq~ selected="selected"~; }
elsif ($INFO{'sort'} eq "" || $FORM{'sortform'} eq "regdate" || $INFO{'sort'} eq "regdate") { $selReg .= qq~ selected="selected"~; }

if ($INFO{'reversed'} || $FORM{'reversed'}) { $selReversed = qq~checked='checked'~; $sortorder = ";order=on"; }

if    ($INFO{'sort'}     ne "") { $sortmode = ";sort=" . $INFO{'sort'}; }
elsif ($FORM{'sortform'} ne "") { $sortmode = ";sort=" . $FORM{'sortform'}; }

$TableHeader .= qq~
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
  <tr>
    <td width="100%" valign="middle" class="titlebg">
    <span style="float: left;"><img src="$imagesdir/register.gif" alt="" border="0" style="vertical-align: middle;" /><b> $admintxt{'17b'}</b></span>
    <span style="float: right;">
    <b>$ml_txt{'1'}</b>
    <form action="$adminurl?action=approvalmembers" method="post" name="selsort" style="display: inline">
    <select name="sortform" style="font-size: 9pt;" onchange="submit()">
    <option value="username"$selUser>$ml_txt{'35'}</option>
    <option value="regdate"$selReg>$ml_txt{'233'}</option>
    </select>
    <b>$admintxt{'37'}</b>
    <input type="checkbox" onclick="submit()" name="reversed" id="reversed" class="titlebg" style="border: 0;" $selReversed />
    </form>
    </span>
	</td>
  </tr>
</table>
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>

<form name="adv_memberview" action="$adminurl?action=approvalmultimembers;$sortmode$sortorder" method="POST" style="display: inline" onSubmit="return submitproc()">
<input type="hidden" name="button" value="0" />
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
<tr>
	<td class="catbg"             align="center">   $approval_txt{'fileprofile'}</td>
	<td class="catbg" width="20%" align="center"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="15%" align="center"><b>$ml_txt{'307'}</b></td> 
	<td class="catbg" width="20%" align="center"><b>$ml_txt{'234'}</b></td>
	<td class="catbg" width="10%" align="center"><b>$approval_txt{'IP'}</b></td>
	<td class="catbg" width="15%" align="center"><b>$approval_txt{'regstatus'}</b></td>
	<td class="catbg" width="15%" align="center"><b>$amv_txt{'4'}<br />$amv_txt{'5'}</b></td>
	<td class="catbg" width="15%" align="center"><b>$approval_txt{'approval'} $approval_txt{'ordelete'}</b></td>
</tr>
~;

$TableFooter = qq~</table>~;


if ($action ne 'approvalmultimembers' && $action ne 'viewpreprofile') { 
#	&LoadReason;
	if ($FORM{'sortform'} eq "username" || $INFO{'sort'} eq "username") { &MLByName }
	elsif ($INFO{'sort'} eq "" || $FORM{'sortform'} eq "regdate" || $INFO{'sort'} eq "regdate") { &MLDate }
}

sub LoadWaitList {
	if (! -e "$memberdir/waitlist.txt") { &CreateWaitList };
	fopen(WAIT, "$memberdir/waitlist.txt");
	@waitlist=<WAIT>;
	fclose(WAIT);

	foreach $waituser (@waitlist) {
		chomp $waituser;
#		&CreateWaitList if $waituser && ! -e "$memberdir/$waituser.wait";
		&CreateWaitList if $waituser && (! -e "$memberdir/$waituser.wait" || (! -e "$memberdir/$waituser.vars" && ! -e "$memberdir/$waituser.wait.vars"));
	}
}

sub CreateWaitList {
	opendir(WAIT, $memberdir);
	@waitlist = grep { /\.wait$/} readdir(WAIT);
	closedir(WAIT);

	fopen (WAIT, ">$memberdir/waitlist.txt");
	foreach $waituser (@waitlist) {
		chomp $waituser;
		$waituser =~ s/\.wait$//;

		if ( -e "$memberdir/$waituser.vars" || -e "$memberdir/$waituser.wait.vars") {
			print WAIT "$waituser\n";
		} else {
			unlink("$memberdir/$waituser.wait");
		}
	}
	fclose (WAIT);
}

sub MLByName {
	&is_admin_or_gmod;
	&LoadWaitList;
	$yymain .= qq~$TableHeader~;

#	$yymain .= qq~@waitlist~;
	foreach $waituser (@waitlist) {
		chomp $waituser;
		if ($waituser) {
			&LoadUser($waituser);
			&LoadPreUser($waituser) if !$_;
			$ToShow[@ToShow]="$waituser|${$uid.$waituser}{'realname'}";
		}
	}

	if ($FORM{'reversed'} || $INFO{'reversed'}) {
		@ToShow = sort {(split /\|/,$b)[1] cmp (split /\|/,$a)[1]} @ToShow;
	} else {
		@ToShow = sort {(split /\|/,$a)[1] cmp (split /\|/,$b)[1]} @ToShow;
	}
	$memcount = @ToShow;

	$start = $start > $memcount - 1 ? $memcount - 1 : $start;
	$start = (int($start / $MembersPerPage)) * $MembersPerPage;

	$b         = $start;
	$numshown  = 0;
	$actualnum = 0;

	if ($memcount) {
		while (($numshown < $MembersPerPage)) {
			($tempname, undef) = split(/\|/, $ToShow[$b]);
			&showRows($tempname);
			$numshown++;
			$b++;
		}
	} else {
		$yymain .= qq~ <td class="windowbg" colspan="6" align="center"><br /><b>$approval_txt{'noentry'}</b><br /><br /></td>~;
	}
	undef @ToShow;

	$yymain .= qq~$TableFooter~;
	&buildPages;
	$yytitle     = "$ml_txt{'312'}";
	$action_area = "approvalmembers";
	&AdminTemplate;
	exit;
}

sub MLDate {
	&is_admin_or_gmod;
	&LoadWaitList;
	$yymain .= qq~$TableHeader~;

	foreach $waituser (@waitlist) {
		chomp $waituser;
		if ($waituser) {
			&LoadUser($waituser);
			&LoadPreUser($waituser) if !$_;
			$ToShow[@ToShow]="$waituser|${$uid.$waituser}{'regtime'}";
		}
	}

	if ($FORM{'reversed'} || $INFO{'reversed'}) {
		@ToShow = sort {(split /\|/,$b)[1] cmp (split /\|/,$a)[1]} @ToShow;
	} else {
		@ToShow = sort {(split /\|/,$a)[1] cmp (split /\|/,$b)[1]} @ToShow;
	}
	$memcount = @ToShow;

	$start = $start > $memcount - 1 ? $memcount - 1 : $start;
	$start = (int($start / $MembersPerPage)) * $MembersPerPage;

	$b = $start;
	$numshown = 0;
	$actualnum = 0;

	if ($memcount) {
		while (($numshown < $MembersPerPage)) {
			($tempname, undef) = split(/\|/, $ToShow[$b]);
			&showRows($tempname);
			$numshown++;
			$b++;
		}
	} else {
		$yymain .= qq~ <td class="windowbg" colspan="6" align="center"><br /><b>$approval_txt{'noentry'}</b><br /><br /></td>~;
	}
	undef @ToShow;

	$yymain .= qq~$TableFooter~;
	&buildPages;
	$yytitle     = "$ml_txt{'4'} $ml_txt{'233'}";
	$action_area = "approvalmembers";
	&AdminTemplate;
	exit;
}


sub showRows {
	my ($user) = $_[0];
	$date2 = $date;

	if (${$uid.$user}{'realname'} ne "") {

		$dr_regdate = &timeformat(${$uid.$user}{'regtime'});
		$dr_regdate =~ s~(.*)(, 1?[0-9]):[0-9][0-9].*~$1~;

		$userfilelink  = qq~<a href="$adminurl?action=viewpreprofile;username=$user"><img src="$imagesdir/xx.gif" border="0" alt="" title="" /></a>~;
		$userfilelink .= qq~&nbsp;&nbsp;<a href="$scripturl?action=viewprofile;username=$user"><img src="$imagesdir/register.gif" border="0" alt="" title="" /></a>~;

		my $userlink = $link{$user};
		$userlink = qq~<a href="$scripturl?action=viewprofile;username=$user"><b>$user</></a>~;

		my $regtype = $approval_txt{'joined'};
		if ( -e "$memberdir/$user.wait.vars" ) {
			$regtype = $approval_txt{'waitjoin'};
		};

		fopen(APPROVAL, "$memberdir/$user.wait");
		my $ip = <APPROVAL>;
		fclose(APPROVAL);
		$ip = "-" if !$ip;

		my $userlastonline = ${$uid.$user}{'lastonline'};
		if ($userlastonline eq "") {
			$userlastonline = "-";
		} else {
			$date1 = $userlastonline;
			&calcdifference;
			$userlastonline = $result;
		}

		if ($user eq "admin") {
			$addel = qq~&nbsp;~;
		} else {
			$addel = qq~<input type="checkbox" name="member$numshown" value="$user" class="windowbg2" style="border: 0; vertical-align: middle;" />~;
			$actualnum++;
		}
 
		$yymain .= qq~
	<tr>
		<td class="windowbg" align="center">$userfilelink</td>
		<td class="windowbg" width="20%">$userlink</td>
		<td class="windowbg2" width="15%" >${$uid.$user}{'email'}</td>
		<td class="windowbg" width="20%" >$dr_regdate</td>
		<td class="windowbg" width="10%" align="center">$ip</td>
		<td class="windowbg2" width="15%" align="center">$regtype</td>
		<td class="windowbg2" width="15%" align="center">$userlastonline</td>
		<td class="windowbg2" width="15%" align="center">$addel</td>
	</tr>~;
	}
}

sub buildPages {

	unless ($memcount == 0) {
		if ($FORM{'sortform'} eq "") { $FORM{'sortform'} = $INFO{'sort'}; }
		if (!$FORM{'reversed'}) { $FORM{'reversed'} = $INFO{'reversed'}; }

		# Build the page links list.
		$postdisplaynum = 3;     # max number of pages to display
		$max            = $memcount;
		$start          = $start > $memcount - 1 ? $memcount - 1 : $start;
		$start          = (int($start / $MembersPerPage)) * $MembersPerPage;
		$tmpa           = 1;
		$tmpx           = int($max / $MembersPerPage);
		if ($start >= (($postdisplaynum - 1) * $MembersPerPage)) { $startpage = $start - (($postdisplaynum - 1) * $MembersPerPage); $tmpa = int($startpage / $MembersPerPage) + 1; }
		if ($max >= $start + ($postdisplaynum * $MembersPerPage)) { $endpage = $start + ($postdisplaynum * $MembersPerPage); }
		else { $endpage = $max }
		if ($startpage > 0) { $pageindex = qq~<a href="$adminurl?action=approvalmembers;sort=$FORM{'sortform'};letter=$letter;reversed=$FORM{'reversed'}">1</a>&nbsp;...&nbsp;~; }
		if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$adminurl?action=approvalmembers;sort=$FORM{'sortform'};letter=$letter;reversed=$FORM{'reversed'}">1</a>&nbsp;~; }

		for ($counter = $startpage; $counter < $endpage; $counter += $MembersPerPage) {
			$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$adminurl?action=approvalmembers;sort=$FORM{'sortform'};letter=$letter;reversed=$FORM{'reversed'};start=$counter">$tmpa</a>&nbsp;~;
			$tmpa++;
		}
		$tmpx    = $max - $MembersPerPage;
		$outerpn = int($tmpx / $MembersPerPage) + 0;
		$lastpn  = int($memcount / $MembersPerPage) + 1;
		$lastptn = ($lastpn - 1) * $MembersPerPage;
		if ($endpage < $max - ($MembersPerPage)) { $pageindexadd = qq~&nbsp;...&nbsp;~; }
		if ($endpage != $max) { $pageindexadd .= qq~&nbsp;<a href="$adminurl?action=approvalmembers;sort=$FORM{'sortform'};letter=$letter;reversed=$FORM{'reversed'};start=$lastptn">$lastpn</a>~; }
		$pageindex .= $pageindexadd;

		$yymain .= qq~
    <table border="0" width="100%" cellpadding="3" cellspacing="1" class="bordercolor">
    <tr>
      <td class="catbg">
	  <span class="small"><b>$admin_txt{'139'}: $pageindex</b></span>
      </td>
    </tr>
    </table>
    <table border="0" width="100%" cellpadding="3" cellspacing="1" class="bordercolor">
        <tr>
          <td class="windowbg2" colspan="2" align="center" width="50%">
                <span class="small">$amv_txt{'45'}: <input type="checkbox" name="del_mail" value="1" class="windowbg2" style="border: 0; vertical-align: middle;" /></span>
          </td>
          <td class="windowbg2" colspan="2" align="center">
                <span class="small">$approval_txt{'sendapprovedmail'}</span>
          </td>
        </tr>
        <tr>
          <td class="windowbg" colspan="2" align="center">
                <input type="submit" value="$amv_txt{'15'}" onclick="javascript:window.document.adv_memberview.button.value = '3'; return confirm('$amv_txt{'20'}')" />
          </td>
          <td class="windowbg" colspan="2" align="center">
                <input type="submit" value="$approval_txt{'appmembers'}" onclick="javascript:window.document.adv_memberview.button.value = '4'; return confirm('$approval_txt{'popup'}')" />
          </td>
        </tr>
    </table>
    <br /><br />

    <table border="0" width="100%" cellpadding="3" cellspacing="1" class="bordercolor">
        <tr>
          <td class="windowbg2" colspan="2" align="left" width="100%">
                $approval_txt{'addtomail'}: <input type="text" size=80  name="addtomail" class="windowbg2" vertical-align: middle;" />
          </td>
        </tr>
    </table>
  </form>
	~;
	}
}

sub ApprovalMultiMembers {
	&is_admin_or_gmod;
	my ($count, $currentmem, $start, $sortmode, $sortorder);

	chomp $FORM{"button"};
	if ($FORM{"button"} ne "3" && $FORM{"button"} ne "4") { &admin_fatal_error($admin_txt{'1'}); }

	fopen(FILE, "$memberdir/memberlist.txt");
	@memnum = <FILE>;
	fclose(FILE);
	$count = 0;

	while (@memnum >= $count) {
		$currentmem = $FORM{"member$count"};
		if (exists $FORM{"member$count"}) {
		#	&UserCheck($currentmem, "realname+email");
			&LoadUser($currentmem);
			&LoadPreUser($currentmem) if !$_;

			if ($FORM{"button"} eq "3" && $FORM{"del_mail"}) {
				$emailsubject = $approval_txt{'maildisapprovedsubject'};
				$emailtext = qq~$approval_txt{'maildisapprovedtext'}\n$FORM{"addtomail"}~;
			}
			if ($FORM{"button"} eq "4" ) {
				$emailsubject = $approval_txt{'mailapprovedsubject'};
				$emailtext  = qq~$approval_txt{'mailapprovedtext'}\n$FORM{"addtomail"}~;
				$emailtext .= qq~\n\n$approval_txt{'mailgotoforum'}\n$scripturl~;
			}
# Approval
			if ($needapproval == 3) { # 3: approval before join;
				# user is in list and the keys match, so let him/her in
				rename("$memberdir/$currentmem.wait.vars", "$memberdir/$currentmem.vars");
				#&UserCheck($reguser, "email");
				&MemberIndex("add", $currentmem);
			}

			$emailsubject =~ s~\[name\]~${$uid.$currentmem}{'realname'}~ig;
			$emailsubject =~ s~\[username\]~$currentmem~ig;

			$emailtext =~ s~\[name\]~${$uid.$currentmem}{'realname'}~ig;
			$emailtext =~ s~\[username\]~$currentmem~ig;

			if ($emailtext ne "") { &sendmail(${$uid.$currentmem}{'email'}, $emailsubject, $emailtext); }

			if ($FORM{'button'} eq "3") {
				unlink("$memberdir/$currentmem.dat");
				unlink("$memberdir/$currentmem.vars");
				unlink("$memberdir/$currentmem.msg");
				unlink("$memberdir/$currentmem.log");
				unlink("$memberdir/$currentmem.rlog");
				unlink("$memberdir/$currentmem.outbox");
				unlink("$memberdir/$currentmem.storage");
				unlink("$memberdir/$currentmem.wait");
				unlink("$memberdir/$currentmem.wait.vars");

				&RemoveReason($currentmem);
				&MemberIndex("remove", $currentmem);
			}
			if ($FORM{'button'} eq "4") {
				unlink("$memberdir/$currentmem.wait");
				if (-e "$memberdir/$currentmem.wait.vars" ){
					rename("$memberdir/$currentmem.wait.vars", "$memberdir/$currentmem.vars");
					&UserAccount($currentmem, "register");
					&MemberIndex("add", $currentmem);
					&FormatUserName($currentmem);
				}
			}
		}
		$count++;
	}

	if ($INFO{'start'} ne "") { $startmode = $INFO{'start'}; }
	if ($INFO{'sort'}  ne "") { $sortmode  = ";sort=" . $INFO{'sort'}; }
	if ($INFO{'order'}) { $sortorder = ";reversed=" . $INFO{'order'}; }

	$yySetLocation = qq~$adminurl?action=approvalmembers;start=$startmode$sortmode$sortorder~;
	&redirectexit;
}

sub LoadPreUser {
	my $user = $_[0];
	my $setting;
	if (${$uid.$user}{'realname'} ne "") { return 1; }
	if ($user eq "") { return 1; }
	$yyload .= qq~Loaded $user <br />~;
	if (-e "$memberdir/$user.wait.vars") {
		fopen(LOADUSER, "$memberdir/$user.wait.vars");
		my @settings = <LOADUSER>;
		fclose(LOADUSER);
		foreach $setting (@settings) {
			chomp $setting;
			unless (length($setting) == 0) {
				$setting =~ s/\'(.*?)\'\,\"(.*?)\"//ig;
				my $tag   = $1;
				my $value = $2;
				${$uid.$user}{$tag} = $value;
			}
		}
	}
	else { return; } # not found userfile

	if (${$uid.$user}{'weburl'} && ${$uid.$user}{'weburl'} !~ m~\Ahttp://~) { ${$uid.$user}{'weburl'} = "http://${$uid.$user}{'weburl'}"; }
	&ToChars(${$uid.$user}{'realname'});
	&LoadMiniUser($user);
	&FormatUserName($user);
	if ($stealthurl) {
		&MakeStealthURL(${$uid.$user}{'weburl'});
	}
	return 1;
}

sub ViewPreProfile {
	my $user = $INFO{'username'};
	my $setting;
	my $filename="";

	if (-e "$memberdir/$user.pre") {
		$filename="$user.pre";
	}
	elsif ( -e "$memberdir/$user.wait.vars") {
		$filename="$user.wait.vars";
		$u_status= "- $approval_txt{'notjoinedprofile'}";
	}
	elsif ( -e "$memberdir/$user.vars") {
		$filename="$user.vars";
	}
	fopen(LOADUSER, "$memberdir/$filename");
	@settings = <LOADUSER>;
	fclose(LOADUSER);

	&LoadReason($user);

	$yymain = qq~
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
  <tr>
    <td width="100%" valign="middle" class="titlebg">
    <span style="float: left;"><img src="$imagesdir/register.gif" alt="" border="0" style="vertical-align: middle;" />&nbsp;<b>$user$u_status</b></span>
    </span>
    </td>
  </tr>
  <tr>
    <td class="windowbg2" align="left">
        $approval_txt{'memberreason'}: $reason{$user}
    </td>
  </tr>
</table>
<br />
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
  <tr>
    <td width="100%" valign="middle" class="titlebg">
    <span style="float: left;"><b>&nbsp;$approval_txt{'waituserfile'}: $filename</b></span>
    </span>
    </td>
  </tr>
</table>
    <table border="0" width="100%" cellpadding="3" cellspacing="1" class="bordercolor">
        <tr>
          <td class="windowbg2" align="left" colspan=2>
                <span class="small"><b>$settings[0]</b></span>
          </td>
        </tr>
~;
		for (1..@settings) {
			$setting = $settings[$_];
			chomp $setting;
			next if !$setting;
			$setting =~ s/\'(.*?)\'\,\"(.*?)\"//ig;
			my $tag   = $1;
			my $value = $2;
	$yymain .= qq~
        <tr>
          <td class="windowbg2" align="right">
                <span class="small">$tag</span>
          </td>
          <td class="windowbg2" align="left">
                <span class="small">$value</span>
          </td>
        </tr>
~;
		}
	$yymain .= qq~
    </table>
    <br />
    <center><br /><a href="javascript:history.go(-1)">$admin_txt{'193'}</a></center> 
~;
#	}

	$yytitle     = $approval_txt{'preuserfile'};
	$action_area = "approvalmembers";
	&AdminTemplate;
	exit;
}

sub LoadReason {
	### load reason
	my $reasonuser = $_[0];

	fopen(REASON, "$memberdir/regreason.txt");
	@reasons = <REASON>;
	fclose(REASON); 

	chomp @reasons;
	$reason{$reasonname}="";
	for ($i=0; $i<@reasons;$i++) {
		my ($reasonname,$reasontxt,$reasondate) = split(/\|/, $reasons[$i]); 
		#$reason{$reasonname} = $reasontxt if $reasontxt;
		if ($reasonname eq $reasonuser) { $reason{$reasonname} = $reasontxt; last;}
	}
}

sub RemoveReason {
	### delete reason
	my $removeuser=$_[0];

	fopen(REASON, "$memberdir/regreason.txt");
	@reasons = <REASON>;
	fclose(REASON);

	chomp @reasons;
	fopen(REASON, ">$memberdir/regreason.txt");
	for ($i=0; $i<@reasons;$i++) {
		my ($reasonname,$reasontxt,$reasondate) = split(/\|/, $reasons[$i]); 
		print REASON qq~$reasons[$i]\n~ if ($reasonname ne $removeuser) && $reasondate;
	}
	fclose(REASON);
}

1;
